


angular.module('geo2.controllers')
    .controller('AddCtrl', ['$scope', 'apiservice', function($scope, apiservice) {
        console.log("add controller running");


        $scope.add_working = false;


        $scope.bool_options = 
            [{
                "key": true,
                "name": "Yes"
            },
            {
                "key": false,
                "name": "No"
            }];

        $scope.trueOnly_options = [{
            "key": true,
            "name": "Yes"
        }];    
		/* What we need for building form: 
			Services:
				apiservice.getDataElement.get({elementId: <elementid>}, function(result) { callback... });		
				apiservice.getOptionSet.get({elementId: <elementid>}, function(result) { callback... });
        
        get optionSets for data elements -> build form based on values 
        eg: mode of discharge (iDFPKpFTiVw) options: Discharged, Died, Transferred, Absconded, Unspecified


		*/
        

        /*
            Add entry -> when $scope.function_name = function() ... we are able to call it from frontend
            by using ng-click="add_entry"
        */
        $scope.add_entry = function() {
            
            console.log("add button pressed");
            $scope.add_working = true;
            // Required fields verification
            for (var i = 0; i < $scope.elemnts.length; i++){
                if ($scope.elemnts[i].compulsory &&  $scope.elemnts[i].value == null){
                    alert($scope.elemnts[i].name + " is required field!");
                    $scope.add_working = false;
                    return;
                }
            }

            if (!$scope.selected_program || !$scope.selected_org_unit) {
                alert("Program and/or organisation unit is not set... Make selection in home tab");
                $scope.add_working = false;
                return;
            }

            if (!$scope.coordinates) {
                alert("Location required, click on map to set location or use button");
                $scope.add_working = false;
                return;
            }
            // Create json to be send to server
            var recorded = get_today();

            var coordinate = {
                "latitude": $scope.coordinates.pb,
                "longitude": $scope.coordinates.qb
            }
            
            var newentry = {
                "program": $scope.selected_program.id,
                "orgUnit": $scope.selected_org_unit.id,
                "eventDate": recorded,
                "status": "COMPLETED",
                "storedBy": $scope.user.userCredentials.code,
                "coordinate": coordinate,
                "dataValues": []
            }

            // Add data elements, no verification so far!
            for (var i = 0; i < $scope.elemnts.length; i++){
                var data_value = {
                    "dataElement": $scope.elemnts[i].id,
                    "value": $scope.elemnts[i].value
                }
                newentry.dataValues.push(data_value);
            }

            console.log("new entry to be send to the server:");
            console.log(newentry);
            
            apiservice.postEvent.query({}, newentry, function(res) {
                console.log("response:");
             	console.log(res);

                if (res.ignored != 0){
                    var error_mes = "";
                    for (var i = 0; i < res.importSummaries.length; i++){
                        for (var j=0; j < res.importSummaries[i].conflicts.length; j++){
                            error_mes += res.importSummaries[i].conflicts[j].value + '\n';
                        }
                    }
                    $scope.add_working = false;
                    alert(error_mes);
                } else {
                    // clear fields
                    for (var i = 0; i< $scope.elemnts.length; i++){
                        if ($scope.elemnts[i].type == "select"){
                            $scope.elemnts[i].value = $scope.elemnts[i].optionSet[0];
                        } else $scope.elemnts[i].value = "";
                    }
                    $scope.add_working = false;
                    alert("New data entry stored successfully!");
                    $scope.$emit('addComplete');
                }


            });
        }

        /*
           Get today date
         */
        function get_today() {
            var today = new Date();
            var dd = today.getDate();
            var mm = today.getMonth()+1; //January is 0!

            var yyyy = today.getFullYear();
            if(dd<10){dd='0'+dd} if(mm<10){mm='0'+mm} 
            return yyyy+'-'+mm+'-'+dd;
        }




    }]);