 /*Suggestion!!! Javascript guidelines for this project:
		* no camelCase function names: use function_names
		* short description for all functions, for educational purpose
*/

angular.module('geo2.controllers', [])
.controller('MainCtrl', ['$scope','$rootScope', 'apiservice', function($scope, $rootScope, apiservice) {
        console.log("Controller loading... correct version");
        /*==============Controller variables / Config ===========================*/
        $scope.programs = [];
        
        $scope.data_set;        //data sets connected to the org unit
        $scope.elemnts = [];
        $scope.some_test;
        
        $scope.event_fields = [];

        $scope.coordinates;
        //$scope.selected_program; //copies the values from homectrl
        //$scope.selected_pstage;
        //$scope.selected_org_unit;

        //stored in the system entries
        $scope.entries = [];

        
        //controll variables
        $scope.data_loaded = false;
        $scope.events_loaded = false;
        $scope.show_table = false;
        //date variables... jquery datepicker? need validation for dates
            

        $scope.startDate;
        $scope.endDate;
       // $scope.startDate = new Date("2012-01-01");
       // $scope.endDate = new Date("2013-12-31");

        //helper variables for customizing when testing
        //might have to be changed to suite your needs.
        //$scope.home_url = "http://localhost:8080/dhis";
        //$scope.temp_url = "http://apps.dhis2.org/demo";
/*
        var program_name = "Decease Tracking";
        var org_unit_name = "Sierra Leone";
        var org_unit_id = "ImspTQPwCqd"; // org unit id of the Sierra Leone
*/      

        /*  ==========================================
            Initialize system, retrieve all needed id's - program id, data elements id's
        */
        $scope.init = function() {
            //Check if system has needed program for single event registration
            console.log("running MainCtrl init");
            
            setup_user(); //if this passes:
        }
        
        $scope.$on('loggedIn', function() {
            get_programs();
        })

        /*  ==========================================
           GET the program with the corresponding program name
         */
        function get_programs() {
            console.log("\tlets get the programs");
            /*Get the all programs using service*/
            var programs = apiservice.getPrograms.get({}, function(programs) {
                get_program_details(programs);
            });
        }

        /*  ==========================================
            GET details for the relevant programs (SINGLE_EVENT_WITHOUT_REGISTRATION)
                args: list of programs
        */
        function get_program_details(data) {
            var count = 0;
            var r;
            for(var i = 0; i < data.programs.length; i++) {
                
                if(data.programs[i].kind === "SINGLE_EVENT_WITHOUT_REGISTRATION") {
                    count++; //this approach might lead to unexpected results, temporary solution...
                    r = apiservice.getProgramDetails.query({programId: data.programs[i].id}, function(prog) {
                        $scope.programs.push(prog);
                        if (--count === 0) {
                            $scope.data_loaded = true; //we have our programs details
                        }
                    });                                 //not a problem when we only have one program with SEWOR
                }
            }
        }
       
        $scope.toggleTable = function () {
            if ($scope.show_table) {
                $scope.show_table = false;
            } else {
                $scope.show_table = true;
            }
        }

        $scope.$on('addComplete', function (event) {
            console.log("add completed, get new events");
            $scope.get_events();
        });

        $scope.$on('newCoords', function(event, coords) {
            console.log("New coordinates");

            $scope.coordinates = coords;
        });

        $scope.$on('startDate', function (event, startDate) {
            $scope.startDate = startDate;
        });

        $scope.$on('endDate', function (event, endDate) {
            $scope.endDate = endDate;
        });
        
        $scope.$on('programSelected', function(event, prog) {
            console.log("MainCtrl recieved program from selector");
            if ( $scope.selected_program != prog ) {
                $scope.selected_program = prog;
                $scope.selected_pstage = undefined;
                $scope.selected_org_unit = undefined;
            }
        });

        

        $scope.$on("pstageSelected", function(event, pstage) {
            console.log("MainCtrl recieved pstage from selector");
            console.log(pstage);
            if (pstage === $scope.selected_pstage) {
                return; //to avoid extra gets
            }
            $scope.selected_pstage = pstage;
            
            //get details and extract data elements for building form
            apiservice.getProgramStages.get({pstageId: pstage.id }, function (res) {
                if (res.programStageDataElements) {
                    $scope.elemnts = [];
                    // Obtained dataElements do not contain all needed information (type, etc.), we need to retrieve it from DataElement 
                    for (var i = 0; i < res.programStageDataElements.length; i++){
                        // Construct dataElement structure
                        var dataElement = {
                            "compulsory" : res.programStageDataElements[i].compulsory,
                            "name" : res.programStageDataElements[i].dataElement.name,
                            "id" : res.programStageDataElements[i].dataElement.id,
                            "optionSet" : null,
                            "type" : null,
                            "value" : null
                        }
                        // Add new dataElement to the list
                        $scope.elemnts.push(dataElement);

                        // Set missing data
                        apiservice.getDataElement.get({elementId: dataElement.id }, function (res) {
                            // Not the most efficient way to access and change data elements...
                            for (var i = 0; i < $scope.elemnts.length; i++)
                                if ($scope.elemnts[i].id === res.id){
                                    // Add type and optionSet
                                    $scope.elemnts[i].type = res.type;
                                    console.log(res.type);
                                    if (res.type === "bool"){
                                        $scope.elemnts[i].value = true;
                                    } else if (res.type === "trueOnly"){
                                        $scope.elemnts[i].value = true;
                                    }

                                    // Retrieve options from optionSet
                                    if (res.optionSet != null){
                                         $scope.elemnts[i].optionSet = res.optionSet.id;
                                         apiservice.getOptionSet.get({optionSetId: res.optionSet.id}, function (res) {
                                            console.log("Got option set:");
                                            console.log(res);
                                            // Need to find proper dataElement again?
                                            for (var i = 0; i< $scope.elemnts.length; i++){
                                                if ($scope.elemnts[i].optionSet != null && $scope.elemnts[i].optionSet === res.id){
                                                    $scope.elemnts[i].optionSet = res.options;
                                                    $scope.elemnts[i].type = "select";
                                                    $scope.elemnts[i].value = res.options[0];
                                                    break;
                                                }
                                            }
                                        });
                                    }
                                    break;
                                }
                        });
                        
                    }
                    
                    //$scope.elemnts = res.programStageDataElements;
                } else {
                    console.log("No data elements found for " + pstage.id);
                }
            })
        });

        $scope.$on("orgUnitSelected", function(event, ou) {
            // Inform mapcontroller to update markers
            $scope.$broadcast('eventsLoaded');

            if (ou === $scope.selected_org_unit) {
                return;
            }
            console.log("got a new org unit" + ou.id);
            $scope.selected_org_unit = ou;
        });

        $scope.$on('eventsFiltered', function (event) {
            $scope.$broadcast('eventsLoaded');
        });

        /*  ==========================================
            GET all the data elements in a program stage...
        */
        $scope.get_events = function() {
            apiservice.getEventsForProgramStage.query({
                programId: $scope.selected_program.id, 
                orgUnitId: $scope.selected_org_unit.id,
                startDate: $scope.startDate,
                endDate: $scope.endDate,

            }, function(result) {
                console.log($scope.startDate + " " + $scope.endDate);
                console.log(result);
                if (result.eventList) {
                    // Clear previous events
                    $scope.events = [];
                    $scope.events_loaded = false;
                    // Clear previous headers
                    $scope.event_fields = [];
                    
                    console.log("Got an eventlist with " + result.eventList.length + " events");
                    
                    // Filter events without coordinates
                    for (var i = 0; i < result.eventList.length; i++){
                        // Set headers
                        if ($scope.event_fields.length == 0){
                            for (var j = 0; j< result.eventList[i].dataValues.length; j++){
                                var new_field_id = result.eventList[i].dataValues[j].dataElement;
                                var new_field_header = "";
                                var new_field_type = "";
                                // Look for name among dataElements
                                for (k = 0; k < $scope.elemnts.length; k++){
                                    if ($scope.elemnts[k].id === new_field_id){
                                        new_field_header = $scope.elemnts[k].name;
                                        new_field_type = $scope.elemnts[k].type;
                                        break;
                                    }
                                }
                                var new_field = {
                                    "id": new_field_id,
                                    "header": new_field_header,
                                    "type": new_field_type,
                                    "filterValue": null
                                }
                                $scope.event_fields.push(new_field);
                            }
                        }


                        if (result.eventList[i].coordinate.latitude != 0.0 && result.eventList[i].coordinate.longitude != 0.0) {

                            // Because dataValues for events are in different order, we need to ensure they all are in the same
                            result.eventList[i].sortedDataValues = [];
                            result.eventList[i].filtered = true;
                            for (var j = 0; j < $scope.event_fields.length; j++){
                                var found = false;
                                for (var k = 0; k< result.eventList[i].dataValues.length; k++){
                                    if ($scope.event_fields[j].id === result.eventList[i].dataValues[k].dataElement){
                                        result.eventList[i].sortedDataValues.push(result.eventList[i].dataValues[k]);
                                        found = true;
                                        break;
                                    }
                                }
                                if (!found) result.eventList[i].sortedDataValues.push(null);
                            }


                            $scope.events.push(result.eventList[i]);
                        }
                    }
                    $scope.events_loaded = true;
                    // Inform mapcontroller
                    $scope.$broadcast('eventsLoaded');
                } 
                else {
                    alert("No events found");
                }
            });
            console.log("Query consists of\nprogram id: " +$scope.selected_program.id + "\norgunit id: " + $scope.selected_org_unit.id + "\nstartdate " + $scope.startDate + " enddate: " + $scope.endDate);
        }

        $scope.test_stuff = function() {
            get_all_events();

        }
        
        /*
            GET user name 
        */
        function setup_user() {
            //return API-call to http://apps.dhis2.org/demo/api/me
            apiservice.getUser.get({}, function success(u) {
                if (u.name) {
                    $scope.user = u;
                    
                    console.log("Hello " + $scope.user.name);
                    $scope.$emit('loggedIn');
                } else {
                    alert("You are not logged in");
                    $scope.data_loaded = true;
                }
            });
        }

        $scope.whereAmI = function() {
            console.log('whereAmI');
            $scope.$broadcast('findMe');
        }
}]);

