
angular.module('geo2.controllers')
    .controller('MapCtrl', ['$scope', '$rootScope', function($scope, $rootScope) {
        console.log("map controller is running");
        
        //init
        

        var start_coord = new google.maps.LatLng(8.6154,-13.2027); //brute force 

        var mapOptions = {
            zoom: 5,
            center: start_coord,
            mapTypeControl: true,
            mapTypeControlOptions: {
                style: google.maps.MapTypeControlStyle.DROPDOWN_MENU
            },
			zoomControl: true,
            zoomControlOptions: {
            style: google.maps.ZoomControlStyle.SMALL,
			}
        };       


        var markers = [];
        var map = new google.maps.Map(
            document.getElementById("map"), mapOptions
        );
        
        google.maps.event.addListener(map, 'click', function (e) {
            setCurrentPos(e.latLng);
        });

        var infowindow = new google.maps.InfoWindow({
            content: ""
        });

        function notifyView () {
            var $notify = $("#coord");

            if($notify.is(":visible")) {return;}
            
            $notify.show();
            setTimeout(function() {
                $notify.hide();
            }, 4000);
        }

        function setCurrentPos (latLng) {
            var coords;
            if (latLng.coords) {
                coords = new google.maps.LatLng(latLng.coords.latitude, latLng.coords.longitude);
            } else {
                coords = new google.maps.LatLng(latLng.pb, latLng.qb);
            }
            console.log(coords);
            
            notifyView(); 
            

            $scope.$emit('newCoords', coords);
        }

        $scope.$on('findMe', function (event) {
            if (navigator.geolocation) {
                navigator.geolocation.getCurrentPosition(setCurrentPos, 
                    function() {
                        console.log("geolocation failure");
                    });
            }
            else {
                alert("Geolocation API not supported.");
            }
        });

        
    
        $scope.$on('eventsLoaded', function(event) {
            $scope.infoWindows = [];

            console.log("mapctrl got events");
            removeMarkers();
            console.log($scope.events);

            if (!$scope.events) { //hacky solution
                return;
            }

            for (var i = 0; i < $scope.events.length; ++i) {
                
                if (!$scope.events[i].filtered) {
                    $scope.events[i].filtered = true;
                    continue;
                }

                //if (events[i].coordinate.latitude != 0.0 && events[i].coordinate.longitude != 0.0) { We don't need this anymore...
                var coord = new google.maps.LatLng($scope.events[i].coordinate.latitude, $scope.events[i].coordinate.longitude);

                // Define context, will be used to store name:value pairs and display it on the marker
                var context = "";

                // Go through all data elements associated with chosen program
                for (var j = 0; j < $scope.elemnts.length; j++) {
                    // Seeking for their values, adding to context variable
                    
                    for (var k = 0; k < $scope.events[i].dataValues.length; k++) {
                        if ($scope.elemnts[j].id === $scope.events[i].dataValues[k].dataElement) {
                            context += '<br>'+$scope.elemnts[j].name+': '+$scope.events[i].dataValues[k].value;
                            break;
                        }
                    }
                }
                var marker = new google.maps.Marker({
                    position: coord,
                    map: map,
                    icon:'http://maps.google.com/mapfiles/ms/icons/green-dot.png',
                    title: context, //TODO: Some more info?
                });

                bindInfoWindow(marker, map, infowindow, context);  


                markers.push(marker); 
                //}
            }
        });
        
        function bindInfoWindow(marker, map, infowindow, html) { 
            google.maps.event.addListener(marker, 'click', function() {
                infowindow.setContent(html); 
                infowindow.open(map, marker); 

            });
        }
        /*
            Clears all markers from map
        */       
        function removeMarkers(){
            for(i=0; i < markers.length; i++) {
                markers[i].setMap(null);
            }
            markers = [];
        }

/*        //recieve broadcast from mainctrl NOT IN USE
        $scope.$on('newOrgUnit', function(event, data) {
            if (!data.coordinates) { //no coordinates
                return
            }
            //can we use explode or simmilar function, bet there is a jquery function for this
            var data_array = data.coordinates.split(','); //take the first coordinates (some have multiple)
            
            var lat_str = data_array[0].replace('[', '');
            var lat = parseFloat(lat_str);

            var lng_str = data_array[1].replace(']', '');
            var lng = parseFloat(lng_str);
            //=================================================
//            console.log(lat + "..." + lng);
            
            var coords = new google.maps.LatLng(lng, lat); //brute force, lets find a better way...
            var marker = new google.maps.Marker({
                position: coords,
                map: map,
				icon:'http://maps.google.com/mapfiles/ms/icons/green-dot.png',
                title: data.name
            });
            markers.push(marker);
//            console.log(markers.length);
        });
*/

}]);
