'use strict';

var home_url = "http://apps.dhis2.org/demo/api/";


angular.module('geo2.service', ['ngResource'])
    .factory('apiservice', ['$resource', 
    	function ($resource) {
		
        //I have not found out how to make multiple queries to a single resource..., might be to strict on address naming 
        //:<value> is parameters sent in from service calls
        return {
    		getUser: $resource(home_url + "me.json", {}, {
            	get: {method:'GET', isArray:false}
            }),        	

        	getPrograms: $resource(home_url + "programs.json", {}, {
        		get: {method:'GET', isArray:false}
            }),

            getProgramDetails: $resource(home_url + "programs/:programId.json", {}, {
        		query: {method:'GET', isArray:false}
            }),

            getOrgUnit: $resource(home_url + "organisationUnits/:orgUnitId.json", {}, {
            	get: {method:'GET', isArray:false}
            }),
            
            getProgramStages: $resource(home_url + "programStages/:pstageId.json", {}, {
                get: {method:'GET', isArray:false}
            }),


//Given a template /path/:verb and parameter {verb:'greet', salutation:'Hello'} results in URL /path/greet?salutation=Hello.

            getEventsForProgramStage: $resource(home_url + "events.json?program=:programId&orgUnit=:orgUnitId&startDate=:startDate&endDate=:endDate&includeChildren=true", {}, {
                query: {method:'GET', isArray:false}
            }),
            
            getOptionSet: $resource(home_url + "optionSets/:optionSetId.json", {}, {
                get: {method:'GET', isArray:false}
            }),

            getDataElement: $resource(home_url + "dataElements/:elementId.json", {}, {
                get: {method:'GET', isArray:false}
            }),
            
            postEvent: $resource(home_url + "events/", {}, {
                query: {method:'POST', isArray:false, withCredentials:true, headers:{'Content-Type': 'application/json'}}
            })	
		}
	}]);